config/routes.rb
require 'sidekiq/web'

Rails.application.routes.draw do

  root to: 'pages#landing'

  get '/about', to: 'pages#about', as: :about
  get '/tos', to: 'pages#tos', as: :tos
  get '/demo', to: 'pages#demo', as: :demo

  get '/badness/:secret', to: 'pages#badness'

  match '/404', to: 'pages#not_found', via: :all
  match '/422', to: 'pages#unacceptable', via: :all
  match '/500', to: 'pages#internal_error', via: :all

  match '/wiki' => redirect('https://github.com/Gamocosm/Gamocosm/wiki'), as: :wiki, via: :get
  match '/issues' => redirect('https://github.com/Gamocosm/Gamocosm/issues'), as: :issues, via: :get
  match '/source' => redirect('https://github.com/Gamocosm/Gamocosm'), as: :source, via: :get
  match '/git_head' => redirect("https://github.com/Gamocosm/Gamocosm/tree/#{Gamocosm::GIT_HEAD}"), as: :git_head, via: :get
  match '/license' => redirect('https://github.com/Gamocosm/Gamocosm/blob/master/LICENSE'), as: :license, via: :get
  match '/blog' => redirect('http://gamocosm.com/blog/'), as: :blog, via: :get
  match '/irc' => redirect('https://webchat.esper.net/?channels=gamocosm'), as: :irc, via: :get
  match '/irc_history' => redirect('http://irc.gamocosm.com'), as: :irc_history, via: :get

  scope '/wiki' do
    match '/ftp_ssh' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/FTP-and-SSH'), as: :wiki_ftp_ssh, via: :get
    match '/minecraft_versions' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Installing-different-versions-of-Minecraft'), as: :wiki_minecraft_versions, via: :get
    match '/server_advanced_tab' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Server-advanced-tab-documentation'), as: :wiki_server_advanced_tab, via: :get
    match '/server_additional_info' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Additional-Info-for-Server-Admins'), as: :wiki_server_additional_info, via: :get
    match '/troubleshooting' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Troubleshooting'), as: :wiki_troubleshooting, via: :get
  end

  scope '/digital_ocean' do
    get '/setup', to: 'pages#digital_ocean_setup', as: :digital_ocean_setup

    match '/index' => redirect('https://www.digitalocean.com/?refcode=f787055e1099'), as: :digital_ocean_index, via: :get
    match '/index_no_ref' => redirect('https://www.digitalocean.com/'), as: :digital_ocean_index_no_ref, via: :get
    match '/pricing' => redirect('https://www.digitalocean.com/pricing/?refcode=f787055e1099'), as: :digital_ocean_pricing, via: :get
    match '/pricing_no_ref' => redirect('https://www.digitalocean.com/pricing/'), as: :digital_ocean_pricing_no_ref, via: :get
    match '/help' => redirect('https://www.digitalocean.com/help/'), as: :digital_ocean_help, via: :get
    match '/control_panel' => redirect('https://cloud.digitalocean.com'), as: :digital_ocean_control_panel, via: :get
    match '/status' => redirect('https://status.digitalocean.com'), as: :digital_ocean_status, via: :get

    get 'droplets', to: 'servers#show_digital_ocean_droplets', as: :show_digital_ocean_droplets
    delete 'droplets/:id', to: 'servers#destroy_digital_ocean_droplet', as: :destroy_digital_ocean_droplet
    get 'snapshots', to: 'servers#show_digital_ocean_snapshots', as: :show_digital_ocean_snapshots
    delete 'snapshots/:id', to: 'servers#destroy_digital_ocean_snapshot', as: :destroy_digital_ocean_snapshot
    get 'ssh_keys', to: 'servers#show_digital_ocean_ssh_keys', as: :show_digital_ocean_ssh_keys
    post 'ssh_keys', to: 'servers#add_digital_ocean_ssh_key', as: :add_digital_ocean_ssh_key
    delete 'ssh_keys/:id', to: 'servers#destroy_digital_ocean_ssh_key', as: :destroy_digital_ocean_ssh_key
    delete 'cache', to: 'servers#refresh_digital_ocean_cache', as: :refresh_digital_ocean_cache
  end

  scope '/external' do
    match '/github_student_developer_pack' => redirect('https://education.github.com/pack'), as: :external_github_student_developer_pack, via: :get
  end

  scope '/cuberite' do
    match '/' => redirect('http://cuberite.org'), as: :cuberite_website, via: :get
    match '/repo' => redirect('https://github.com/cuberite/cuberite'), as: :cuberite_repo, via: :get
  end

  Sidekiq::Web.use Rack::Auth::Basic, 'Protected Area' do |u, p|
    u == Gamocosm::SIDEKIQ_ADMIN_USERNAME && p == Gamocosm::SIDEKIQ_ADMIN_PASSWORD
  end
  mount Sidekiq::Web => '/sidekiq'

  devise_for :users, controllers: { registrations: 'registrations' }

  resources :servers, path: '/servers' do
    collection do
      post 'new', to: 'servers#create', as: :create
    end
    member do
      get 'delete'
      get 'start'
      get 'stop'
      get 'pause'
      get 'resume'
      get 'backup'
      get 'download'
      get 'reboot'
      put 'update_properties'
      post 'add_friend'
      post 'remove_friend'
      post 'command'
      get 'autoshutdown_enable'
      get 'autoshutdown_disable'
      get 'clear_logs'
    end
  end

end

app/controllers/servers_controller.rb
class ServersController < ApplicationController
  before_action :authenticate_user!

  def new
    @server = Server.new
    @server.minecraft = Minecraft.new

    load_new
  end

  def edit
  end

  def show
    @server = find_server(params[:id])
  end

  def load_index
    @friend_servers = current_user.friend_servers
  end

  def load_new
    if !current_user.digital_ocean_missing?
      @do_regions = Gamocosm.digital_ocean.region_list
      @do_sizes = Gamocosm.digital_ocean.size_list
    end
  end

  def index
    @servers = current_user.servers
    load_index
  end

  def create
    begin
      @server = current_user.servers.create!(server_params)
      return redirect_to server_path(@server), flash: { success: 'You made a new server! Start it to play' }
    rescue
      @server = Server.new(server_params)
      # run validations for error messages
      @server.valid?
      @do_regions = Gamocosm.digital_ocean.region_list
      @do_sizes = Gamocosm.digital_ocean.size_list
      flash[:error] = 'Something went wrong. Please try again'
      load_new
      return render :new
    end
  end

  def update
    @server = find_server_only_owner(params[:id])
    # can be ftp ssh tab, schedule tab, or advanced tab
    ssh_keys = server_ssh_keys_params[:ssh_keys]
    if ssh_keys.nil?
      p = server_schedule_params
      @server_tab = :schedule
      schedule_text = nil
      if p[:timezone_delta].nil?
        p = server_advanced_params
        if !p[:minecraft_attributes].nil?
          p[:minecraft_attributes][:id] = @server.minecraft.id
        end
        @server_tab = :advanced
      else
        if !p[:minecraft_attributes].nil?
          p[:minecraft_attributes][:id] = @server.minecraft.id
        end
        schedule_text = p.delete(:schedule_text)
      end
      if @server.update_attributes(p)
        if @server_tab != :schedule || @server.parse_and_save_schedule(schedule_text)
          return redirect_to server_path(@server), flash: { success: (@server_tab == :schedule ? 'Server schedule updated' : 'Server advanced configuration updated') }
        end
      end
    else
      @server.ssh_keys = ssh_keys
      if @server.save
        message = 'Server SSH keys updated'
        if !@server.ssh_keys.blank?
          message += '. They will be added the next time you start the server'
        end
        return redirect_to server_path(@server), flash: { success: message }
      end
      @server_tab = :ftp_ssh
    end
    flash[:error] = 'Something went wrong. Please try again'
    return render :show
  end

  def destroy
    @server = find_server_only_owner(params[:id])
    @server.remove_domain
    error = @server.remote.destroy_saved_snapshot
    if error
      return redirect_to server_path(@server), flash: { error: "Unable to delete saved server snapshot: #{error}" }
    end
    error = @server.remote.destroy
    if error
      return redirect_to server_path(@server), flash: { error: "Unable to delete server: #{error}" }
    end
    @server.delete
    return redirect_to servers_path, flash: { success: 'Server is deleting' }
  end

  def delete
    @server = find_server_only_owner(params[:id])
    return render :delete
  end

  def start
    @server = find_server(params[:id])
    error = @server.start
    if error
      flash[:error] = "Unable to start server: #{error}. Please contact the server admin about this"
    else
      @server.user.invalidate_digital_ocean_cache_droplets
      flash[:success] = 'Server starting'
    end
    return redirect_to server_path(@server)
  end

  def stop
    @server = find_server(params[:id])
    error = @server.stop
    if error
      flash[:error] = "Unable to stop server: #{error}. Please contact the server admin about this"
    else
      flash[:success] = 'Server stopping'
    end
    return redirect_to server_path(@server)
  end

  def reboot
    @server = find_server(params[:id])
    error = @server.reboot
    if error
      flash[:error] = "Unable to reboot server: #{error}. Please contact the server admin about this"
    else
      flash[:success] = 'Server is rebooting'
    end
    return redirect_to server_path(@server)
  end

  def resume
    @server = find_server(params[:id])
    error = @server.minecraft.resume
    if error
      flash[:error] = "Unable to start Minecraft: #{error}. Please contact the server admin about this"
    else
      flash[:success] = 'Server resumed'
    end
    return redirect_to server_path(@server)
  end

  def pause
    @server = find_server(params[:id])
    error = @server.minecraft.pause
    if error
      flash[:error] = "Unable to stop Minecraft: #{error}. Please contact the server admin about this"
    else
      flash[:success] = 'Server paused'
    end
    return redirect_to server_path(@server)
  end

  def backup
    @server = find_server(params[:id])
    error = @server.minecraft.backup
    if error
      flash[:error] = "Unable to backup world: #{error}. Please contact the server admin about this"
    else
      flash[:success] = 'World backed up remotely on server'
    end
    return redirect_to server_path(@server)
  end

  def download
    @server = find_server(params[:id])
    error = @server.minecraft.download?
    if error
      return redirect_to server_path(@server), flash: { error: "Unable to download world: #{error}. Please contact the server admin about this" }
    end
    return redirect_to @server.minecraft.world_download_url
  end

  def command
    @server = find_server(params[:id])
    command = minecraft_command_params[:data]
    error = @server.minecraft.exec(current_user, command)
    if error
      return redirect_to server_path(@server), flash: { error: "Unable to send command to Minecraft: #{error}. Please contact the server admin about this" }
    end
    return redirect_to server_path(@server), flash: { success: 'Command sent' }
  end

  def update_properties
    @server = find_server_only_owner(params[:id])
    if !@server.running?
      return redirect_to server_path(@server), flash: { error: 'Server isn\'t running. Start it to edit Minecraft properties' }
    end
    res = @server.minecraft.node.update_properties(minecraft_properties_params)
    if res.error?
      return redirect_to server_path(@server), flash: { error: "Unable to update Minecraft properties: #{res}. Please contact the server admin about this" }
    end
    return redirect_to server_path(@server), flash: { success: 'Minecraft properties updated' }
  end

  def add_friend
    @server = find_server_only_owner(params[:id])
    email = server_friend_params[:email]
    friend = User.find_by_email(email)
    if friend.nil?
      return redirect_to server_path(@server), flash: { error: "User #{email} does not exist" }
    end
    if @server.owner?(friend)
      return redirect_to server_path(@server), notice: 'You are already the owner of the server'
    end
    if @server.friend?(friend)
      return redirect_to server_path(@server), notice: "User #{email} is already on this server"
    end
    @server.friends << friend
    return redirect_to server_path(@server), flash: { success: "User #{email} added to the server" }
  end

  def remove_friend
    @server = find_server_only_owner(params[:id])
    email = server_friend_params[:email]
    friend = User.find_by_email(email)
    if friend.nil?
      return redirect_to server_path(@server), flash: { error: "User #{email} does not exist" }
    end
    @server.friends.delete(friend)
    return redirect_to server_path(@server), flash: { success: "User #{email} removed from the server" }
  end

  def autoshutdown_enable
    @server = find_server_only_owner(params[:id])
    @server.minecraft.update_columns(autoshutdown_enabled: true)
    if @server.remote.exists?
      AutoshutdownMinecraftWorker.perform_in(64.seconds, @server.id)
    end
    return redirect_to server_path(@server), flash: { success: 'Autoshutdown enabled' }
  end

  def autoshutdown_disable
    @server = find_server_only_owner(params[:id])
    @server.minecraft.update_columns(autoshutdown_enabled: false)
    return redirect_to server_path(@server), flash: { success: 'Autoshutdown disabled' }
  end

  def clear_logs
    @server = find_server_only_owner(params[:id])
    @server.logs.delete_all
    return redirect_to server_path(@server), flash: { success: 'Server logs cleared' }
  end

  def show_digital_ocean_droplets
    @do_droplets = current_user.digital_ocean_droplets
    render layout: nil
  end

  def destroy_digital_ocean_droplet
    error = current_user.digital_ocean.droplet_delete(params[:id])
    current_user.invalidate_digital_ocean_cache_droplets
    if error
      return redirect_to servers_path, flash: { error: error }
    end
    return redirect_to servers_path, flash: { notice: 'Deleted droplet on Digital Ocean' }
  end

  def show_digital_ocean_snapshots
    @do_snapshots = current_user.digital_ocean_snapshots
    render layout: nil
  end

  def destroy_digital_ocean_snapshot
    error = current_user.digital_ocean.image_delete(params[:id])
    current_user.invalidate_digital_ocean_cache_snapshots
    if error
      return redirect_to servers_path, flash: { error: error }
    end
    return redirect_to servers_path, flash: { notice: 'Deleted snapshot on Digital Ocean' }
  end

  def show_digital_ocean_ssh_keys
    @do_ssh_keys = current_user.digital_ocean_ssh_keys
    render layout: nil
  end

  def add_digital_ocean_ssh_key
    ssh_key_name = params[:digital_ocean_ssh_key][:name]
    ssh_public_key = params[:digital_ocean_ssh_key][:data]
    f = { success: 'Added SSH public key to Digital Ocean' }
    ssh_key = current_user.digital_ocean.ssh_key_create(ssh_key_name, ssh_public_key)
    if ssh_key.error?
      f = { error: ssh_key }
    end
    return redirect_back fallback_location: servers_path, flash: f
  end

  def destroy_digital_ocean_ssh_key
    error = current_user.digital_ocean.ssh_key_delete(params[:id])
    current_user.invalidate_digital_ocean_cache_ssh_keys

app/helpers/servers_helper.rb
module ServersHelper
  def server_status_class(server)
    if server.pending_operation
      'text-warning'
    elsif server.remote.error?
      'text-danger'
    elsif server.running?
      'text-success'
    else
      'text-muted'
    end
  end

  def server_minecraft_status_class(server)
    if !server.busy? && server.minecraft.pause?.nil?
      'text-success'
    else
      'text-muted'
    end
  end

  def breadcrumb_back_to_servers
    link_to servers_path, class: "basic-breadcrumb" do
      "Servers <span class='fa fa-angle-right'></span>".html_safe
    end
  end
end

app/views/servers/_advanced.html.erb
<%= simple_form_for @server, (@demo.nil? ? { url: server_path(@server), method: :put } : { html: { onsubmit: 'return false;' } }) do |f| %>
	<%= panel_with_heading 'Advanced Configuration' do %>
		View the documentation for these fields on the <%= link_to 'wiki', wiki_server_advanced_tab_path %>.
		<br /><br />
		<%= f.input :ssh_port, label: 'SSH port' %>
		<%= f.input :pending_operation %>
		<%= f.input :setup_stage %>
		<%= f.input :remote_snapshot_id, label: 'Digital Ocean saved snapshot id' %>
		<%= f.input :remote_region_slug, label: 'Digital Ocean region slug' %>
		<%= f.input :remote_size_slug, label: 'Digital Ocean size slug' %>
		<%= f.simple_fields_for :minecraft do |f_m| %>
			<%= f_m.input :mcsw_password, label: 'MCSW key', as: :string %>
		<% end %>
		<%= f.button :submit, 'Update', class: 'btn btn-success' %>
	<% end %>
<% end %>

app/views/servers/_busy.html.erb
<% content_for :head do %>
	<meta http-equiv="refresh" content="8" />
<% end %>
<div>
	<% if @server.pending_operation == 'starting' %>
		Your server is being created.
		<% if !@server.done_setup? %>
			This should take a few minutes (first time only).
		<% else %>
			This should take about a minute.
		<% end %>
	<% elsif @server.pending_operation == 'preparing' %>
		<% if !@server.done_setup? %>
			Your server is being set up.
			This should take a few minutes (first time only).
		<% else %>
			Your server is being started. This should take about a minute.
		<% end %>
		<br />
		Status:
		<% if @server.setup_stage == 0 %>
			Connecting
		<% elsif @server.setup_stage == 1 %>
			Connected
		<% elsif @server.setup_stage == 2 %>
			Installing and updating software (usually 2-3 minutes)
		<% elsif @server.setup_stage == 3 %>
			Downloading and installing Minecraft (<%= @server.minecraft.flavour_info.try(:[], :name) %>, estimated <%= pluralize_with_count(@server.minecraft.flavour_info.try(:[], :time), 'minute') %>)
		<% elsif @server.setup_stage == 4 %>
			Finishing up
		<% elsif @server.setup_stage == 5 %>
			Keeping system up to date
		<% end %>
	<% elsif @server.pending_operation == 'stopping' %>
		Your server is shutting down.
		This should take about 15 seconds.
	<% elsif @server.pending_operation == 'saving' %>
		Your server is being backed up.
		This should take about a minute.
	<% elsif @server.pending_operation == 'rebooting' %>
		Your server is rebooting.
		This should only take a few seconds.
	<% else %>
		Hmmmm.
	<% end %>
	<br />
	This page will automatically refresh itself, but feel free to refresh it yourself.
	<hr />
	<%= render partial: 'advanced' %>
	<%= render partial: 'logs' %>
	<hr />
	<%= link_to 'Delete', delete_server_path(@server), class: 'btn btn-danger', data: { confirm: 'Are you sure you want to delete this server forever? (A really long time!)' } %>
</div>
<br />

app/views/servers/_create.html.erb
<% if current_user.digital_ocean_missing? %>
	Gamocosm is an <%= link_to 'open source project', source_path %> to help players host cloud Minecraft servers, but Gamocosm doesn't host the servers ourselves.
	Create an account on <%= render_digital_ocean_referral_link('%s (%s)', 'Digital Ocean', digital_ocean_index_path, digital_ocean_index_no_ref_path) %>, a server host, and enter your API token in your <%= link_to 'settings', edit_user_registration_path %>.
	<strong>If you are not a server admin, you can ignore this.</strong>
	Read more about it <%= link_to 'here', digital_ocean_setup_path %>.
<% else %>
	<%= simple_form_for @server, url: new_server_path do |f| %>
		<%= f.input :name, input_html: { size: 32 }, required: true %>
		<%= f.input :remote_size_slug, collection: @do_sizes.collect { |x| [x.descriptor, x.slug] }, as: :select, include_blank: true, label: 'Size' %>
		<%= f.input :remote_region_slug, collection: @do_regions.collect { |x| [x.name, x.slug] }, as: :select, include_blank: true, label: "Region (#{link_to('higher tier better', 'https://en.wikipedia.org/wiki/Data_center#Data_center_tiers')})".html_safe %>
		<%= f.simple_fields_for :minecraft do |s_f| %>
			<%= s_f.input :flavour, collection: Gamocosm::MINECRAFT_FLAVOURS.collect { |k, v| [v[:name], k] }, as: :select, include_blank: true, label: 'Minecraft flavour', required: true %>
		<% end %>
		<div>
			<%= render partial: 'flavour', collection: Gamocosm::MINECRAFT_FLAVOURS.map { |k, v| [k, v] } %>
		</div>
		<p class="help-block">
			Have you tried <%= link_to 'Cuberite', cuberite_website_path %>, the performant C++ Minecraft server?
			You can always change your server/setup yourself.
			<%= link_to 'Read more', wiki_minecraft_versions_path %>
		</p>
		<br />
		<%= link_to 'Digital Ocean pricing page', digital_ocean_pricing_no_ref_path %>
		<button class="btn btn-default pull-right" type="submit">
			Next <i class="fa fa-chevron-right"></i>
		</button>
	<% end %>
<% end %>

app/views/servers/_friend.html.erb
<li>
	<%= simple_form_for :server_friend, url: remove_friend_server_path(@server), method: :post do |f| %>
		<%= f.input :email, as: :hidden, input_html: { value: friend.email } %>
		<div class="friend">
			<span class="email"><%= friend.email %></span>
			<span class="actions">
				<%= f.button :submit, 'Remove', class: 'btn btn-default' %>
			</span>
		</div>
	<% end %>
</li>

app/views/servers/_ftp_ssh.html.erb
<%= panel_with_heading 'Server Credentials' do %>
	<p>FTP and SSH instructions are on the <%= link_to 'wiki', wiki_ftp_ssh_path %>.</p>
	<table class="ftp-details table">
		<tr><th scope="row">Host</th><td><%= render_server_ip_address(@server, 'Your server\'s IP address when running') %></td></tr>
		<tr><th scope="row">Port</th><td><%= @server.ssh_port %></td></tr>
		<tr><th scope="row">User</th><td>mcuser</td></tr>
		<tr><th scope="row">Password</th>
		<td><p>Defaults to your email and the name of your server separated with a plus, e.g. "steve@example.com+terrafirmacraft" (<strong>you should change this!</strong>)</p>
			<p>Even if you specify SSH key(s) to add to your server, a password must be set for you to use sudo</p>
		</td></tr>
		<tr><th scope="row">FTP Protocol</th><td>SFTP</td></tr>
		<tr><th scope="row">FTP Logon Type</th><td>Normal (saves password) or Ask for password (every time)</td></tr>
	</table>
<% end %>

<%= panel_with_heading 'Changing your server password' do %>
	<ol>
		<li>SSH into your server</li>
		<li>Run <code>passwd</code></li>
		<li>Enter your old and new password into the prompt</li>
		<li>Exit (run <code>exit</code>)</li>
	</ol>
<% end %>

<%= panel_with_heading 'SSH Keys' do %>
	<p>
		The next time you start your server, Gamocosm will add these keys to your list of authorized keys (and reset this field)
	</p>
	<%= form_for @server, (@demo.nil? ? { url: server_path(@server), method: :put } : { html: { onsubmit: 'return false;' } }) do |f| %>
		<%= f.label :ssh_keys, class: "sr-only" %>
		<div class="input-group">
			<%= f.text_field :ssh_keys, class: "form-control" %>
			<span class="input-group-btn">
				<%= f.submit 'Save', class: 'btn btn-default' %>
			</span>
		</div>
		<p class="help-block">Comma separated list of Digital Ocean SSH key IDs (spaces will be stripped)</p>
	<% end %>
	<hr />
	<h4>SSH keys on Digital Ocean</h4>
	<% if @demo.nil? %>
		<table id="digital_ocean_ssh_keys" class="table table-striped table-no_fixed" data-url="<%= show_digital_ocean_ssh_keys_path %>">
			<tr><td><i>Fetching data ...</i></td></tr>
		</table>
	<% else %>
		<table class="table table-striped table-no_fixed">
			<tr>
				<th>Name</th>
				<th class="text-right">ID</th>
				<th>&nbsp;</th>
			</tr>
			<tr>
				<td>me</td>
				<td class="text-right">123</td>
				<td><a class="btn btn-default pull-right">Delete</a></td>
			</tr>
			<tr>
				<td>gamocosm</td>
				<td class="text-right">456</td>
				<td><a class="btn btn-default pull-right">Delete</a></td>
			</tr>
		</table>
	<% end %>
	<hr />
	<h4>Add SSH public key to Digital Ocean</h4>
	<%= simple_form_for :digital_ocean_ssh_key, (@demo.nil? ? { url: add_digital_ocean_ssh_key_path, method: :post } : { html: { onsubmit: 'return false;' } }) do |f| %>
		<%= f.input :name %>
		<%= f.input :data, as: :text, label: 'SSH Public Key' %>
		<%= f.button :submit, 'Add', class: 'btn btn-default' %>
	<% end %>
<% end %>

app/views/servers/_logs.html.erb
<div class="row">
	<div class="col-sm-12">
		<div class="panel panel-default">
			<div class="panel-heading">
				<h4 class="panel-title">
					<a data-toggle="collapse" href="#server_log_panel" aria-controls="server_log_panel" aria-expanded="false">
						<span class="fa fa-sort"></span> Server Log (<%= @server.logs.size %>)
					</a>
				</h4>
			</div>

			<div id="server_log_panel" class="panel-body <%= 'collapse' if !@server.busy? %>">
				<% if @server.logs.count == 0 %>
					<em>No messages</em>
				<% else %>
					<% @server.logs.order('created_at DESC').each do |x| %>
						<p><div>
							<%= x.when %>
							<div class="pull-right"><%= x.debuginfo %></div>
							<br />
							<%= x.message %>
						</div></p>
					<% end %>
					<% if @server.owner?(current_user) %>
						<%= link_to 'Clear', clear_logs_server_path(@server), class: 'btn btn-default pull-right' %>
					<% end %>
				<% end %>
			</div>
		</div>
	</div>
</div>

app/views/servers/_tips.html.erb
<div class="row">
	<div class="col-sm-12">
		<%= panel_with_heading 'Tips' do %>
			<ul>
				<li>Always back up your server locally!</li>
				<li>Stop the physical server when no-one is playing.
				Digital Ocean charges you when the server is running.
				</li>
				<li>Stop Minecraft before backing up or downloading your world, or editing files (configuration, mods, plugins, etc.)</li>
				<li>If something fails while setting up the server, try the "reboot" button.
				It will attempt the process again.
				</li>
				<li>For more information read the <%= link_to 'About page', about_path %> or the <%= link_to 'wiki', wiki_path %></li>
				<li>For problems, check the <%= link_to 'Troubleshooting page', wiki_troubleshooting_path %> on the wiki, or submit an issue on <%= link_to 'GitHub', issues_path %></li>
			</ul>
		<% end %>
	</div>
</div>

app/views/servers/index.html.erb
<% title 'My Servers - Gamocosm' %>
<div class="row">
	<div class="col-sm-12">
		<div class="page-header">
			<h1>
				Servers <small>for <%= current_user.email %></small>
				<div class="pull-right">
					<%= link_to new_server_path, class: 'btn btn-lg btn-primary' do %>
						<span class="fa fa-plus"></span> Create server
					<% end %>
					<%= link_to 'Open a support ticket', issues_path, class: 'btn btn-lg btn-default' %>
				</div>
			</h1>
		</div>
	</div>
</div>

<div class="row">
	<div class="col-sm-12">
		<table class="table table-striped">
			<thead>
				<tr>
					<td colspan="2">Name</td>
					<td colspan="3">Domain / IP Address</td>
					<td>Status</td>
				</tr>
			</thead>
			<tbody>
			<% if @servers.blank? && @friend_servers.blank? %>
				<tr>
					<td colspan="6" class="text-center">
						<em>You have no servers</em>
					</td>
				</tr>
			<% else %>
				<%= render partial: 'server', collection: @servers %>
				<%= render partial: 'server', collection: @friend_servers %>
			<% end %>
			</tbody>
		</table>
	</div>
</div>
<% if !current_user.digital_ocean_missing? %>
	<%= render partial: 'digital_ocean_panel' %>
<% end %>